package com.javlininc;

import org.jetel.component.normalize.DataRecordNormalize;
import org.jetel.data.DataRecord;
import org.jetel.exception.TransformException;

import org.jetel.exception.ComponentNotReadyException;
import java.net.UnknownHostException;
import java.util.Set;

import com.mongodb.DBCursor;
import com.mongodb.Mongo;
import com.mongodb.DB;
import com.mongodb.DBCollection;
import com.mongodb.DBObject;
import com.mongodb.MongoException;



public class MongoDBReader extends DataRecordNormalize {

	Mongo m; 
	DB db;
	DBCursor cursor;
	
	@Override
	public void preExecute() throws ComponentNotReadyException {
		super.preExecute();
		System.out.println("starting");
		try {
			m = new Mongo("localhost", 27017);
			db = m.getDB( "mydb" );
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MongoException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Set<String> colls = db.getCollectionNames();
		for (String collectionName : colls) {
			DBCollection coll = db.getCollection(collectionName);
			System.out.println(collectionName + ": " + coll.getCount());
		}
	}
	
	@Override
	public int count(DataRecord arg0) throws TransformException {
		DBCollection coll = db.getCollection("testCollection");
		cursor = coll.find();
		System.out.println("collection size = " + cursor.count());
		return cursor.count();
	}

	@Override
	public int transform(DataRecord source, DataRecord target, int arg2) throws TransformException {
		DBObject json = cursor.next();
		System.out.println("json document: '" + json.toString() + "'");
		target.getField("json").setValue(json.toString());
		return 0;
	}

}
