package com.javlininc;

import org.jetel.component.DataRecordTransform;
import org.jetel.data.DataRecord;
import org.jetel.data.StringDataField;
import org.jetel.exception.ComponentNotReadyException;
import org.jetel.exception.TransformException;
import java.net.UnknownHostException;
import java.util.Set;

import com.mongodb.Mongo;
import com.mongodb.DB;
import com.mongodb.DBCollection;
import com.mongodb.DBObject;
import com.mongodb.MongoException;
import com.mongodb.WriteConcern;
import com.mongodb.WriteResult;
import com.mongodb.util.JSON;
import com.sun.org.apache.bcel.internal.generic.NEW;



public class MongoDBWriter extends DataRecordTransform {
	Mongo m; 
	DB db;
	
	@Override
	public void preExecute() throws ComponentNotReadyException {
		super.preExecute();
		System.out.println("starting");
		try {
			m = new Mongo("localhost", 27017);
			db = m.getDB( "mydb" );
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MongoException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Set<String> colls = db.getCollectionNames();
		for (String collectionName : colls) {
			DBCollection coll = db.getCollection(collectionName);
			System.out.println(collectionName + ": " + coll.getCount());
		}
	}
	
	@Override
	public int transform(DataRecord[] source, DataRecord[] target) throws TransformException {
		String json = ((StringDataField)source[0].getField("json")).toString();
		System.out.println("json<" + json + ">");
		DBObject dbObject = (DBObject)JSON.parse(json);
		DBCollection coll = db.getCollection("testCollection");
		WriteResult result = coll.insert(dbObject, WriteConcern.NORMAL);
		((StringDataField)target[0].getField("json")).setValue(Integer.toString(result.getN()));
		return 0;
	}

}
